import torch
import argparse
from environments import NonMfosMetaGames

parser = argparse.ArgumentParser()
parser.add_argument("--game", type=str, default="IPD")
parser.add_argument("--p1", type=str, default="NL")
parser.add_argument("--p2", type=str, default="NL")
args = parser.parse_args()


if __name__ == "__main__":
    batch_size = 8192
    num_steps = 100
    p1, p2, game = args.p1, args.p2, args.game
    env = NonMfosMetaGames(batch_size, game=game, p1=p1, p2=p2)
    env.reset()
    running_rew_0 = torch.zeros(batch_size).cuda()
    running_rew_1 = torch.zeros(batch_size).cuda()
    for i in range(num_steps):
        _, r0, r1, M = env.step()
        running_rew_0 += r0.squeeze(-1)
        running_rew_1 += r1.squeeze(-1)
    mean_rew_0 = (running_rew_0.mean() / num_steps).item()
    mean_rew_1 = (running_rew_1.mean() / num_steps).item()
    print("=" * 100)
    print(f"Done with game: {game}, p1: {p1}, p2: {p2}")
    print(f"r0: {mean_rew_0}, r1: {mean_rew_1}")
